﻿#region [ License information          ]
/* ************************************************************
 *
 * Copyright (c) Bjørn Bouet Smith, 2010, 2011
 *
 * This source code is subject to terms and conditions of 
 * Microsoft Public License (Ms-PL).
 * 
 * A copy of the license can be found in the license.txt
 * file at the root of this distribution. If you can not 
 * locate the License, please send an email to bjornsmith@gmail.com
 * 
 * By using this source code in any fashion, you are 
 * agreeing to be bound by the terms of the Microsoft 
 * Permissive License.
 *
 * You must not remove this notice, or any other, from this
 * software.
 *
 * ************************************************************/
#endregion

namespace Smith.AMC.PerformanceCounters
{
    class PerformanceCounterNames
    {
        public const string AddsPerSecond = "# of Add operations per second";
        public const string AppendsPerSecond = "# of Append operations per second";
        public const string AverageSocketWaitTime = "The average wait time in seconds for a free socket";
        public const string AverageSocketWaitTimeBase = "The average wait time in seconds for a free socket Base";
        public const string CASPerSecond = "# of CAS operations per second";
        public const string DeletesPerSecond = "# of Delete operations per second";
        public const string ErrorsPerSecond = "# of errors per second";
        public const string PrependsPerSecond = "# of Prepend operations per second";
        public const string ReplacesPerSecond = "# of Replace operations per second";
        public const string SetsPerSecond = "# of Set operations per second";
        public const string GetsPerSecond = "# of Get operations per second";
        public const string IncrementsPerSecond = "# of Increment operations per second";
        public const string DecrementsPerSecond = "# of Decrement operations per second";
        public const string TotalCacheOperationsPerSecond = "Total # of cache operations per second";
    }
}
