﻿using NUnit.Framework;
using Smith.AMC.Operations;

namespace MemcachedClientTests
{
    [TestFixture]
    public class IncrementOperationTest
    {

        [Test]
        public void ToStringShouldReturnTheExpectedString()
        {
            const string expectedString = "incr longkey 888";

            IncrementOperation operation = new IncrementOperation
            {
                Key = "longkey",
                Data = 888
            };

            string operationString = operation.ToString();

            Assert.That(operationString, Is.StringContaining(expectedString));
        }
    }
}
